//+------------------------------------------------------------------+
//|                                        FXA0 - Ladderv0.03 EA.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""

/*
   Changelog ver0.03
      takeProfit() will create a variable takeProfit depending on time of market and activity and average pips/bar, right now this
      features is disabled and it is hard coded with default values for EURUSD
*/


extern int MagicNumber = 888888;

extern int PipStep=9;  //this needs logic to determine correct pipstep based on takeprofit
double TakeProfit=0;

double Lots = 0.1; //desired starting lots, this will double to bail you out if necessary
int AccountType=0;  // 0 if Normal Lots, 1 for mini lots, 2 for micro lots

extern int rsi_period=5;
int MaxTrades=2;

int ticket, marketQualityValue=0, OpenOrders=0, cnt=0, slippage=3, lastType=0, PreviousOpenOrders=0, LastTicket=0, LastType=0;
double tp=0, sl=0, BuyPrice=0, SellPrice=0, lotsi=0, mylotsi=0, Profit=0, LastPrice=0, LastLots=0, PipValue=0;
bool ContinueOpening=True;
string text="", text2="";

int profitableTrades=0; //counts profitable trades
int looserTrades=0; //counts looser trades

double averagepipsS=0;
double averagepips=0;
      
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
  
  
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  
  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
//----
   
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=1; }
   
  //finds current profit on last opened order, last type of order and the total number of open orders
  lastType=0; OpenOrders=0;  Profit=0; LastTicket=0; LastPrice=0; LastLots=0;	
  for(cnt=0;cnt<OrdersTotal();cnt++)
  {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {            
          Profit += OrderProfit();       
          OpenOrders ++; 
          if(OrderTicket() > LastTicket)
          {
              LastTicket = OrderTicket();
              LastPrice = OrderOpenPrice();
              LastLots = OrderLots();
              if (OrderType()==OP_BUY) { lastType=1; }
              if (OrderType()==OP_SELL) { lastType=2; }
          }   
       }
  }   
   
   //get dynamic take profit number to check for profits
   TakeProfit=takeProfit();
   
   marketQualityValue=0;
   marketQualityValue=closeQuality();
   //close profitable orders
   if(OpenOrders>=1)
   {
      if(Profit>=TakeProfit) { CloseAllOrders(); Print("Closed for Profit "); profitableTrades++; }  
      //close orders if market changes in opposite direction
      if(lastType==1 && marketQualityValue==2) { CloseAllOrders(); Print("Closed for Change from Buy to Sell"); looserTrades++; }
      if(lastType==2 && marketQualityValue==1) { CloseAllOrders(); Print("Closed for Change from Sell to Buy"); looserTrades++; }
      //if((lastType==1 || lastType==2) && marketQualityValue==5) { CloseAllOrders(); Print("Closed for Sideways Market"); }
   }
   
   //Print ("Profitable Trades " + profitableTrades + " Looser Trades " + looserTrades);
      
   if (OpenOrders>=MaxTrades) 
   { ContinueOpening=False; } 
   else { ContinueOpening=True; }
   

   if(OpenOrders>=0)
   {
      ticket=0;
      marketQualityValue=0;
      marketQualityValue=openQuality();
      
      if(marketQualityValue==1)
      {
         if(OpenOrders==0) { ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,sl,0,"Ladder Long Order",MagicNumber,0,Blue); }
         if(OpenOrders>=1 && ContinueOpening && lastType==1 && ((LastPrice-Ask)>=PipStep*Point))
         { 
            LastLots=LastLots*2; 
            ticket=OrderSend(Symbol(),OP_BUY,LastLots,Ask,slippage,sl,0,"Ladder Long Order",MagicNumber,0,Blue);
         }

         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
         //else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue==2)
      {
         if(OpenOrders==0) { ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,sl,0,"Ladder Short Order",MagicNumber,0,Red); }
         if(OpenOrders>=1 && ContinueOpening && lastType==2 && ((Bid-LastPrice)>=PipStep*Point))
         {
            LastLots=LastLots*2;
            ticket=OrderSend(Symbol(),OP_SELL,LastLots,Bid,slippage,sl,0,"Ladder Short Order",MagicNumber,0,Red);
         }
         if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
         //else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
         return(0);
      }
      if(marketQualityValue==5)
      {
        //Print("No market to open"); 
      }
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| value added functions                                            |
//+------------------------------------------------------------------+

//add quality points to go long, subtract quality points to go short
int openQuality() 
{
	int QualityPoints=0;
	if(iRSI(NULL,0,rsi_period,PRICE_CLOSE,0)>50 && iRSI(NULL,0,rsi_period,PRICE_CLOSE,0)>iRSI(NULL,0,rsi_period,PRICE_CLOSE,1)) { QualityPoints=1; } //go long
	if(iRSI(NULL,0,rsi_period,PRICE_CLOSE,0)<50 && iRSI(NULL,0,rsi_period,PRICE_CLOSE,0)<iRSI(NULL,0,rsi_period,PRICE_CLOSE,1)) { QualityPoints=2; } //go short

	
	
	
	return(QualityPoints);
}

int closeQuality() 
{
	int QualityPoints=0;   
	if(iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,0)>50 && iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,0)>iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,1)) { QualityPoints=1; } //go long
	if(iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,0)<50 && iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,0)<iRSI(NULL,PERIOD_H4,rsi_period,PRICE_CLOSE,1)) { QualityPoints=2; } //go short
	return(QualityPoints);
}

//calculates average bar size during small time frame and during larger time frame, uses as take profit during active and inactive hours
//I would like this function to take the lastType (direction) of the last trade and then return the average pips of the bull bars or the bear bars per the movement
int takeProfit()
{
   int i=0;

   
   /*if(averagepips==0 || averagepipsS==0)
   {
      for (i=iBars(NULL,PERIOD_M15); i>0; i--) //cycles through the chart from beginning to current bar
       {
          if(iOpen(NULL,PERIOD_M15,i)<iClose(NULL,PERIOD_M15,i)) { averagepipsS=averagepipsS+(iClose(NULL,PERIOD_M15,i)-iOpen(NULL,PERIOD_M15,i)); }
          if(iOpen(NULL,PERIOD_M15,i)>iClose(NULL,PERIOD_M15,i)) { averagepipsS=averagepipsS+(iOpen(NULL,PERIOD_M15,i)-iClose(NULL,PERIOD_M15,i)); }
       }
          averagepipsS=averagepipsS/iBars(NULL,PERIOD_M15);
          averagepipsS=averagepipsS*10000;
          averagepipsS=NormalizeDouble(averagepipsS,0);
 
       for (i=iBars(NULL,PERIOD_H1); i>0; i--) //cycles through the chart from beginning to current bar
       {
          if(iOpen(NULL,PERIOD_H1,i)<iClose(NULL,PERIOD_H1,i)) { averagepips=averagepips+(iClose(NULL,PERIOD_H1,i)-iOpen(NULL,PERIOD_H1,i)); }
          if(iOpen(NULL,PERIOD_H1,i)>iClose(NULL,PERIOD_H1,i)) { averagepips=averagepips+(iOpen(NULL,PERIOD_H1,i)-iClose(NULL,PERIOD_H1,i)); }
       }
          averagepips=averagepips/iBars(NULL,PERIOD_H1);
          averagepips=averagepips*10000;
          averagepips=NormalizeDouble(averagepips,0);
    }
    else
    {*/
      //Optimized for EURUSD
      if((Hour()>=0 && Hour()<=4) || (Hour()>=16 && Hour()<=23)) { return(3); }
      else { return(8); }
    //}
}

void CloseAllOrders()
{
   for(cnt=OrdersTotal();cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	   if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {
         if (OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow); }
         if (OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow); }
      }
   }
   return(0);
}

 
 /*   
 
   TODO: Mulitiple Timeframes 5, 15, 30 and H1 
    uses H4 for entry, but needs to verify if also entry on H1, just uses H1 for Close
    
    Keep track of Profit (Winners) vs. Lossers, if lass traid was looser, wait one winner then double entry
      (Double down to increase gains instead of just to recoop losses)
    
    Test RSI moving Average only, TurboJRSX, Pipsetup, starting lots, Different RSI timeframe 7,14,21, Fib#'s, Pie, Log, e
    
    Different pipstep for different times, Pipstep may also need to be variable according to the takeprofit and market tradeing time

- Program will automatically adjust for sweet spots %5, if target is unrealistic (above a all time high or above a 
logical support/resistance it will adjust it)
   -Use this on open orders to make sure entry is near a sweet spot or an alltime high, etc....
   
   -Only take orders in direction of trend, this will help avoid spikes, possibly use XPMA or a moving average line
   
   Bull Strength and Bear Strength and average of each for target profits
      
   Large and Small time frames, if down trend on large look for ups then get in on downs on small
   
   */
 

//val0>0, val1>0, val2==2147483647 //go long - blue
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //   val0>0, val1==2147483647, val2>0  //go short - red
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)!=2147483647) {QualityPoints=2;}//go short
   //val0>0, val1==2147483647, val2==2147483647 //yellow - sideways
	//if(iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"zzz - Trend Histo",0,2,0)==2147483647 || iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=5;}//sideways
	
	/*double downa=iCustom(NULL,PERIOD_H4,"xpMA",0,0,0);
	double downb=iCustom(NULL,PERIOD_H4,"xpMA",0,1,0);
	double downc=iCustom(NULL,PERIOD_H4,"xpMA",0,2,0);
	double downd=iCustom(NULL,PERIOD_H4,"xpMA",0,3,0);
	Print("1: " + downa + "  2: " + downb + "  3: " + downc + "4: " + downd);*/
	
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)!=0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)==0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)!=0) {QualityPoints=2;}//go short

   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=2;}//go short
   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==1 || iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==-1) { QualityPoints=5; }  
   
   	//if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)!=2147483647) {QualityPoints=2;}//go short
	//if(iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"zzz - Trend Histo",0,2,0)==2147483647) {QualityPoints=5;}//sideways
	
   //if(iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,2,0)==2147483647) {QualityPoints=1;}//go long
   //if(iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H1,"Waddah_Attar_Trend",0,2,0)!=2147483647) {QualityPoints=2;}//go short
	
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)!=0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,0,0)==0 && iCustom(NULL,PERIOD_H4,"Waddah_Attar_Trend",0,1,0)!=0) {QualityPoints=2;}//go short

   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=1;}//go long
	//if(iCustom(NULL,PERIOD_H4,"xpMA",0,1,0)!=2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,2,0)==2147483647 && iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==0) {QualityPoints=2;}//go short
   //if(iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==1 || iCustom(NULL,PERIOD_H4,"xpMA",0,3,0)==-1) { QualityPoints=5; }

   /*if(OpenOrders>=1 && ContinueOpening && lastType==1 && ((LastPrice-Ask)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_BUY,LastLots,Ask,slippage,sl,0,"Ladder Long Order",MagicNumber,0,Blue);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Long Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Long Order:  Lots " + lotsi,GetLastError());
      //open another long position
   }
   
   if(OpenOrders>=1 && ContinueOpening && lastType==2 && ((Bid-LastPrice)>=PipStep*Point))
   {
      LastLots=LastLots*2;
      ticket=OrderSend(Symbol(),OP_SELL,LastLots,Bid,slippage,sl,0,"Ladder Short Order",MagicNumber,0,Red);
      if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Ladder Short Order: ",OrderOpenPrice()); }
      else Print("Error opening Ladder Short Order:  Lots " + lotsi,GetLastError());
      //open another short position
   }*/